﻿{{ self.title() }}

豆瓣菜、顿顿

## 题目分析

图的维护 + 数据结构

删点的过程中，维护每个结点的度以及度为2的邻接点数目。

可以使用线段树、平衡树、优先级队列等数据结构快速找到符合贪心策略的结点。

## 子任务设计

测试点1和2，森林，不会使用到贪心策略；

测试点3和4，若干个团，不会用到贪心策略2；

测试点1~6，$n \le {{ tools.hn(prob.args['subn']) }}$ 且 $m \le {{ tools.hn(prob.args['subm']) }}$；

全部10个测试点，$n \le {{ tools.hn(prob.args['n']) }}$ 且 $m \le {{ tools.hn(prob.args['m']) }}$。

## 测试程序

simple.cpp，不考虑策略2，$33$ 分；

naive.cpp，循环枚举符合贪心策略的点，$61$ 分；

std.cpp，使用线段树，$100$ 分。
